package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import java.io.IOException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.DaoOperation;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.EntityMarshaller;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.PathInfoTokenizer;

public class IdAccessHandler extends AbstractGetMethodAccessHandler {

    private final EntityMarshaller entityMarshaller;
    private final PathInfoTokenizer pathInfoTokenizer;
    private final DaoOperation daoOperation;

    public IdAccessHandler(HttpServletRequest request,
            HttpServletResponse response,
            PathInfoTokenizer pathInfoTokenizer,
            DaoOperation daoOperation,
            EntityMarshaller entityMarshaller) {
        super(request, response);
        this.pathInfoTokenizer = pathInfoTokenizer;
        this.daoOperation = daoOperation;
        this.entityMarshaller = entityMarshaller;
    }

    public void handle() throws IOException {
        String daoPrefix = pathInfoTokenizer.getDaoPrefix(request.getPathInfo());
        long entityId = pathInfoTokenizer.getEntityId(request.getPathInfo());
        Object result = daoOperation.getById(daoPrefix, entityId);
        String xml = entityMarshaller.marshal(result);
        writeXml(xml);
    }
}
