package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import java.io.IOException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.DaoOperation;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.EntityListMarshaller;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.EntityMarshaller;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.GetMethodAccessHandler;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.PathInfoTokenizer;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.RestOperationDelegate;

public class RestOperationDelegateImpl implements RestOperationDelegate {
    
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException {
        if(pathInfoTokenizer.isListAccess(request.getPathInfo())) {
            GetMethodAccessHandler handler = new ListAccessHandler(request,
                    response, pathInfoTokenizer,
                    daoOperation, entityListMarshaller);
            handler.handle();
        } else {
            GetMethodAccessHandler handler = new IdAccessHandler(request,
                    response, pathInfoTokenizer,
                    daoOperation, entityMarshaller);
            handler.handle();
        }
    }

    private EntityListMarshaller entityListMarshaller;
    public void setEntityListMarshaller(EntityListMarshaller entityListMarshaller) {
        this.entityListMarshaller = entityListMarshaller;
    }
    private EntityMarshaller entityMarshaller;
    public void setEntityMarshaller(EntityMarshaller entityMarshaller) {
        this.entityMarshaller = entityMarshaller;
    }

    private PathInfoTokenizer pathInfoTokenizer;
    public void setPathInfoTokenizer(PathInfoTokenizer pathInfoTokenizer) {
        this.pathInfoTokenizer = pathInfoTokenizer;
    }
    private DaoOperation daoOperation;
    public void setDaoOperation(DaoOperation daoOperation) {
        this.daoOperation = daoOperation;
    }
}
